﻿using System;
using System.Web;

namespace Coscine.WaterbutlerHelper.ReturnObjects
{
    public class ObjectMetaInfoReturnObject
    {
        public string Name { get; set; }
        public string Path { get; set; }
        public int? Size { get; set; }
        public string Kind { get; set; }
        public DateTime? Modified { get; set; }
        public DateTime? Created { get; set; }
        public string Provider { get; set; }

        public bool IsFolder => Kind.ToLower() == "folder";
        public bool IsFile => Kind.ToLower() == "file";

        public string UploadLink { get; set; }
        public string DeleteLink { get; set; }
        public string DownloadLink { get; set; }

        public ObjectMetaInfoReturnObject()
        {

        }

        public ObjectMetaInfoReturnObject(ObjectMetaInfo objectMetaInfo, string blobApiLink, string resource)
        {
            Name = objectMetaInfo.Name;
            Path = objectMetaInfo.Path;
            Size = objectMetaInfo.Size;
            Kind = objectMetaInfo.Kind;
            Modified = objectMetaInfo.Modified;
            Created = objectMetaInfo.Created;
            Provider = objectMetaInfo.Provider;

            UploadLink = $"{blobApiLink}{resource}/{HttpUtility.UrlEncode(Path)}";
            DeleteLink = $"{blobApiLink}{resource}/{HttpUtility.UrlEncode(Path)}";
            DownloadLink = $"{blobApiLink}{resource}/{HttpUtility.UrlEncode(Path)}";
        }
    }
}
